#!/murwork/kawanabe/bin/ruby 
require "narray"
require "num/complex"
require "num/numarray"
require "benchmark"
include Benchmark
include NMath

#p a = NumComplex[2,4]
na = NArray.float(100,100,100).indgen!
nu = NumArray.span(Float,100,100,100)
#nb = NArray.scomplex(100,100,100).indgen!
#nv = NumArray.span(NumComplex,100,100,100)

#p nb[0,0,0].type

for itetate in 0..0 do
  print "shisoku\n"
  puts measure{ 
    na*na
    na-na
    na/na
    na+na
  }
  puts measure{
    nu*nu
    nu-nu
    nu/nu
    nu+nu
  }

  print "shisoku (with scalar)\n"
  puts measure{ 
    na*1.0
    na-1.0
    na/1.0
    na+1.0
  }
  puts measure{
    nu*1.0
    nu-1.0
    nu/1.0
    nu+1.0
  }

  print "shisoku (with scalar, coerced)\n"
  puts measure{ 
    1.0*na
    1.0-na
    1.0/na
    1.0+na
  }
  puts measure{ 
    1.0*nu
    1.0-nu
    1.0/nu
    1.0+nu
  }

  print "math\n"
  puts measure{ 
    sin(na)
    cos(na)
    tan(na)
  }
  puts measure{ 
    nu.sin
    nu.cos
    nu.tan
  }

  print "sum, av, var, rms\n"
  puts measure{ 
    na.sum
    na.mean
    #(na.stddev)*(na.stddev)
    #na.stddev
  }
  puts measure{
    nu.sum
    nu.av
    #nu.var
    #nu.rms
  }
  print "max, min, median\n"
  puts measure{ 
    #na.max
    #na.min
    #na.median
  }
  puts measure{
    #nu.max
    #nu.min
    #nu.median
  }
  print "transpose\n"
  puts measure{ 
    na.transpose(2,1,0)
  }
  puts measure{
    nu.transpose
  }

  print "\n"
end

